/*
 *	Autor: Maciej Roman   		              
 *	M.Roman@stud.elka.pw.edu.pl     	       		
 *	Temat: Biblioteka STL 
 *	opis algorytmu fill(), fill_n()	 
 *



	Algorytmy fill() i fill_n() uywane s do zastpieina wartoci elementw w kolekcji w podanym zakresie.

	
	Przy uyciu algorytmy fill() uywa si nastpujcego szablonu:
	
	template < class ForwardIterator, class T >
		void fill ( ForwardIterator first, ForwardIterator last, const T& value )

		ForwardIterator first - pierwszy element kolekcji ktry zostanie zastpiony  
		ForwardIterator last - element kolekcj ktry wyzancza koniec zakresu i nie zostanie ju zastpiony 
		const T& value - warto na ktr zostan zamienione elemnty z podanego zakresu

	Algorytm fill() przypisuje warto value do wszystkich elemnentw kolekcji z zakresu [first,last). 
	Zakres obejmuje wszystkie elementy pomidzy start wcznie do last-1.   
	
	Przy uyciu algorytmy fill_n() uywa si nastpujcego szablonu:
	
	template < class OutputIterator, class Size, class T >
		void fill_n ( OutputIterator first, Size n, const T& value );

		ForwardIterator first - pierwszy element kolekcji ktry zostanie zastpiony  
		Size n - ilo zamienonych elemntw zaczynajc o delemntu first
		const T& value - warto na ktr zostan zamienione elemnty z podanego zakresu
	
	Algorytm fill_n() przypisuje warto value do wszystkich elemntw kolejcji z zakresu [first, first+n). 

	Warunkiem dziaania obu algorytmw jest moliwo przypisania wartoci do T,
	oraz w przypadku fill_n() zamiany warotci Size na typ Intiger
 
 */

#include <algorithm>
#include <vector>
#include <string>
#include <iostream>


using namespace std;


// Prosta klasa suca do demonstracji
class Towar 
{
private:
	string status;
	int cena;
public:
	Towar()
	{
		status="W sklepie";
		cena=100;
	}
	Towar(string c,int x)
	{
		status=c;
		cena=x;
	}
	void wypisz()
	{
		cout<<status<<endl;
	}
};
//Przykad 1 pokazuje wykorzystanie obu algorytmw w poczeniu z stworzon przez nas klasa i wektorem
int main()
{
	//Stworzenie wektora z towarami;
	vector<Towar> towary;
		
	//Tworzenie towarw
	Towar nieprzeceniony;
	Towar przeceniony("przecenione",50);
	Towar zamowiony("zamowione",0);

	//Dodanie towarw nieprzecenionych do wektora
	for(unsigned int i=0;i<=5;i++)
		towary.push_back(nieprzeceniony);
		
	cout<<"Lista towarow przed zastosowaniem algorytmw: "<<endl;
	for(unsigned int i=0;i<=towary.size()-1;i++)
	 	towary[i].wypisz();
	cout<<endl;

	//Uycie algorytmu fill do zamiany towarw na przecenione oprcz dwch ostatnich
	fill(towary.begin(),towary.end()-2,przeceniony);

	cout<<"Lista towarow po zastosowaniu algorytmu fill() : "<<endl;
	for(unsigned int i=0;i<=towary.size()-1;i++)
	 	towary[i].wypisz();
	cout<<endl;

	// Uycie algorytmu fill_n do zamiany statusu przech pierwszych towarw na zamowione 
	fill_n(towary.begin(),3,zamowiony);

	cout<<"Lista towarow po zastosowaniu algorytmu fill_n(): "<<endl;
	for(unsigned int i=0;i<=towary.size()-1;i++)
	 	towary[i].wypisz();
	cout<<endl;


}





